#include <fstream>
#include <iostream>
#include <queue>
#include <algorithm>
#include <assert.h>
using namespace std;

int n;
int k;
int ls[100000];
int rs[100000];
pair<int, int> liitujad[100000];

priority_queue<int, vector<int>, greater<int> > freetasks;
priority_queue< pair<int, int>, vector< pair<int, int> >, greater< pair<int, int> > > takentasks;

int weeks[100000];

int main() {
    ifstream fin;
    ofstream fout;
    
    fin.open("klubisis.txt");
    fin >> n >> k;
    for (int i = 0; i < k; i++) fin >> ls[i] >> rs[i];
    fin.close();
    
    // Sorteerime klubiliikmed
    for (int i = 0; i < k; i++) {
        liitujad[i].first = ls[i];
        liitujad[i].second = i;
    }
    sort(liitujad, liitujad+k);
    
    // Paneme kõik arvud 1 kuni 100000 pq-sse
    for (int i = 1; i <= 100000; i++) freetasks.push(i);
    
    // Hakkame nädalakaupa simuleerima
    pair<int, int> nexttaken;
    pair<int, int> liituja;
    int liitujaindeks = 0;
    int hiliseim_liige = 0;
    for (int i = 1; i <= n; i++) {
        // Kontrolli, kas mõned eelnevalt hõivatud taskid tuleb tagasi vabade hulka panna
        while (!takentasks.empty()) {
            nexttaken = takentasks.top();
            if (nexttaken.first < i) {
                takentasks.pop();
                freetasks.push(nexttaken.second);
            }
            else break;
        }
        // Hangi task nädal i jaoks
        weeks[i-1] = freetasks.top();
        freetasks.pop();
        // Vaata, kes sel nädalal klubiga liitusid
        while (liitujaindeks < k) {
            liituja = liitujad[liitujaindeks];
            if (liituja.first < i) assert(false);
            else if (liituja.first == i) {
                liitujaindeks++;
                if (hiliseim_liige < rs[liituja.second]) hiliseim_liige = rs[liituja.second];
            }
            else break;
        }
        // Pane task hõivatud taskide nimekirja
        pair<int, int> takentask;
        takentask.first = hiliseim_liige;
        takentask.second = weeks[i-1];
        takentasks.push(takentask);
    }
    
    fout.open("klubival.txt");
    for (int i = 0; i < n; i++) fout << weeks[i] << '\n';
    fout.close();
    
    return 0;
}
