import sys
from fractions import Fraction
from decimal import Context

fi = open('piltsis.txt', 'rt')
fo = open('piltval.txt', 'wt')

inp = iter(map(int, fi.read().split()))
n = next(inp)

pts = [(next(inp), next(inp)) for _ in range(n)]

def orient(a, o, b):
	ax, ay = a
	ox, oy = o
	bx, by = b
	return (ax-ox)*(by-oy) - (ay-oy)*(bx-ox)

def convex_hull(pts):
	def scan(pts):
		it = iter(pts)
		hull = [next(it)]
		for p in it:
			while len(hull) > 1 and orient(hull[-1], hull[-2], p) >= 0:
				hull.pop()
			hull.append(p)
		return hull
	pts.sort()
	up = scan(pts)
	pts.reverse()
	lo = scan(pts)
	assert lo[0] == up[-1]
	assert lo[-1] == up[0]
	return up + lo[1:-1]

def comp(xs, i):
	return list(map(lambda x: x[i], xs))

hull = convex_hull(pts)
hull.append(hull[0])

min_y = min(hull, key=lambda p: p[1])[1]
max_y = max(hull, key=lambda p: p[1])[1]
if min_y == max_y:
	fo.write("0\n")
	fo.close()
	sys.exit()
ls = -(1<<200)
rs = 1<<200
best_l = None
best_r = None
for i in range(len(hull)-1):
	ax, ay = hull[i+0]
	bx, by = hull[i+1]
	dx = bx-ax
	dy = by-ay
	if dy == 0:
		continue
	my = (min_y + max_y)
	denom = dy*2
	num = (max_y-min_y)*(ax*dy*2 + (my - ay*2)*dx)
	s = Fraction(num, denom)
	if ay < by:
		if s > ls:
			ls = s
			best_l = i
	else:
		if s < rs:
			rs = s
			best_r = i
ans = rs-ls
dec = Context(100)
fo.write('{0}\n'.format(dec.divide(ans.numerator, ans.denominator)))
fo.close()
