#include <iostream>
#include <random>
#include <string>
#include <algorithm>

using namespace std;

char randchar () {
  char c = rand() % 53;
  if (c < 26) {
    return 'a' + c;
  } else if (c < 52) {
    return 'A' + c - 26;
  } else {
    return '-';
  }
}

const int maxn = 100005;
string names [maxn];
vector<int> chains [maxn];

int main (int argc, char **argv) {
  srand(atoi(argv[1]));
  for (int i = 0; i < maxn; i++) {
    for (int j = 0; j < 10; j++) {
      names[i].push_back(randchar());
    }
  }

  if (argv[2] == string("-ok")) {
    int vertexc = atoi(argv[3]);
    int chainc = atoi(argv[4]);
    int singc = atoi(argv[5]);
    
    vector<string> frow;
    for (int i = 0; i < vertexc; i++) {
      frow.push_back(names[i]);
    }
    random_shuffle(frow.begin(), frow.end());

    for (int i = singc; i < vertexc; i++) {
      chains[rand() % chainc].push_back(i);
    }

    vector<pair<string, string>> edges;
    for (int i = 0; i < chainc; i++) {
      for (int j = 0; j < (int) chains[i].size() - 1; j++) {
        edges.push_back(make_pair(names[chains[i][j]], names[chains[i][j + 1]]));
      }
    }

    random_shuffle(edges.begin(), edges.end());
    for (int i = 0; i < (int) edges.size(); i++) {
      if (rand() % 2) {
        swap(edges[i].first, edges[i].second);
      }
    }

    cout << vertexc << " " << (int) edges.size() << '\n';
    for (int i = 0; i < vertexc; i++) {
      cout << frow[i];
      if (i != vertexc - 1) {
        cout << " ";
      }
    }
    cout << '\n';

    for (int i = 0; i < (int) edges.size(); i++) {
      cout << edges[i].first << " " << edges[i].second << '\n';
    }
  } else if (argv[2] == string("-bigcyc")) {
    int vertexc = atoi(argv[3]);

    vector<pair<string, string>> edges;
    for (int i = 0; i < vertexc - 1; i++) {
      edges.push_back(make_pair(names[i], names[i + 1]));
    }
    edges.push_back(make_pair(names[0], names[vertexc - 1]));

    random_shuffle(edges.begin(), edges.end());
    for (int i = 0; i < (int) edges.size(); i++) {
      if (rand() % 2) {
        swap(edges[i].first, edges[i].second);
      }
    }

    cout << vertexc << " " << vertexc << '\n';
    for (int i = 0; i < vertexc; i++) {
      cout << names[i];
      if (i != vertexc - 1) {
        cout << " ";
      }
    }
    cout << endl;

    for (int i = 0; i < (int) edges.size(); i++) {
      cout << edges[i].first << " " << edges[i].second << '\n';
    }
  } else if (argv[2] == string("-tree")) {
    int vertexc = atoi(argv[3]);
    int cutoff = atoi(argv[4]);

    vector<pair<string, string>> edges;
    for (int i = 1; i < vertexc; i++) {
      if (rand() < cutoff) {
        edges.push_back(make_pair(names[i], names[rand() % i]));
      }
    }

    random_shuffle(edges.begin(), edges.end());
    for (int i = 0; i < (int) edges.size(); i++) {
      if (rand() % 2) {
        swap(edges[i].first, edges[i].second);
      }
    }

    cout << vertexc << " " << (int) edges.size() << '\n';
    for (int i = 0; i < vertexc; i++) {
      cout << names[i];
      if (i != vertexc - 1) {
        cout << " ";
      }
    }
    cout << endl;

    for (int i = 0; i < (int) edges.size(); i++) {
      cout << edges[i].first << " " << edges[i].second << '\n';
    }
  }
}
