# sisendi korrektsuse kontrollija

import sys
import re

name = re.compile('^[-a-zA-Z]{1,10}$')

fi = open(sys.argv[1], 'rt')
fo = open(sys.argv[2], 'wt')

(n, m) = map(int, fi.readline().split())
if 1 > n or n > 100000:
	sys.exit('N out of range')
if 1 > m or m > 300000:
	sys.exit('M out of range')
fo.write('{0} {1}\n'.format(n, m))

s = fi.readline().split()
if len(s) != n:
	sys.exit('Invalid number of names')
t = set()
for a in s:
	if not name.match(a):
		sys.exit('Invalid name {0}'.format(a))
	if a in t:
		sys.exit('Repeating name {0}'.format(a))
	t.add(a)
fo.write('{0}\n'.format(' '.join(s)))

for i in range(m):
	(a, b) = fi.readline().split()
	if not a in t:
		sys.exit('Unknown name {0}'.format(a))
	if not b in t:
		sys.exit('Unknown name {0}'.format(b))
	fo.write('{0} {1}\n'.format(a, b))

fi.close()
fo.close()

if len(sys.argv) > 3 and sys.argv[3] == '-v':
	if n <= 10 and m <= 30:
		print('subtask 1')
	elif n <= 1000 and m <= 3000:
		print('subtask 2')
	else:
		print('subtask 3')
