#include <fstream>
#include <string>
#include <map>
#include <vector>

using namespace std;

ifstream fi("ridasis.txt");
ofstream fo("ridaval.txt");

const int maxv = 100005;

map<string, int> idx;
string name [maxv];

vector<int> adj [maxv];
bool vis [maxv];
vector<string> ans;

void dfs (int vertex, int parent) {
  vis[vertex] = true;
  ans.push_back(name[vertex]);
  for (int nxt : adj[vertex]) {
    if (nxt != parent) {
      dfs(nxt, vertex);
    }
  }
}

int main () {
  ios::sync_with_stdio(false);

  int vertexc, edgec;
  fi >> vertexc >> edgec;

  for (int i = 0; i < vertexc; i++) {
    fi >> name[i];
    idx[name[i]] = i;
  }

  for (int i = 0; i < edgec; i++) {
    string us, vs;
    fi >> us >> vs;

    int u = idx[us], v = idx[vs];
    adj[u].push_back(v);
    adj[v].push_back(u);
  }

  for (int i = 0; i < vertexc; i++) {
    if ((int) adj[i].size() > 2) {
      fo << "EI SAA" << endl;
      return 0;
    }
  }

  for (int i = 0; i < vertexc; i++) {
    if (!vis[i] && (int) adj[i].size() <= 1) {
      dfs(i, -1);
    }
  }

  if ((int) ans.size() == vertexc) {
    fo << "SAAB" << endl;
    for (int i = 0; i < vertexc; i++) {
      fo << ans[i];
      if (i != vertexc - 1) {
        fo << " ";
      }
    }
    fo << endl;
  } else {
    fo << "EI SAA" << endl;
  }
}
